Subject: Re: What is the status of GSoC 2022 work on making Git use roaring bitmaps?

From: Jakub Narębski <[email-masked]>
Date: Thu, 23 Mar 2023 23:01:46 +0100

Hello Taylor,

Thanks for a fast response.

Taylor Blau <[email-masked]> writes:
> On Thu, Mar 23, 2023 at 08:26:11PM +0100, Jakub Narębski wrote:
>> Hello,
>>
>> Could you tell me what is the status of the Abhradeep Chakraborty work
>> in integrating roaring bitmaps (using CRoaring) in addition to, or
>> replacing current EWAH bitmaps (using ewok)? The last communication
>> about this shows that the patches were on the road to being merged in,
>> see e.g. https://medium.com/@abhra303/gsoc-final-report-feaaacfae737 ,
>> but there is no mention of 'roaring' in Git's code or documentation.
>
> Abhradeep started working on a prototype to teach Git how to read and
> write Roaring+Run bitmaps in this series:
>
>   https://lore.kernel.org/git/[email-masked]/
>
> Some folks gave it a review, but there wasn't any serious traction and I
> don't think that Abhradeep has had a chance to come back to the series.
>
> For what it's worth, I would love if Abhradeep (or anybody else
> interested in working on this area) picked it back up, either using that
> series as a starting point or going from scratch.

When I searched the mailing list archives, the thread was never continued.

>> Moreover, there is no proposal to finish this on the GSoC 2023 ideas
>> page: https://git.github.io/SoC-2023-Ideas/ .  Is it because it would be
>> too small of a project?  Or maybe it turned out that roaring bitmaps
>> were not a good idea - though I haven't found mentions of any benchmarks
>> of roaring vs EWAH in the mailing list archives?  Or perhaps there is no
>> one to mentor this proposal?
>
> I don't have the capacity to mentor a student this cycle, and I am
> probably the most interested among potential mentors in seeing this
> project through ;-).

Ah, so it is mostly the last issue - lack of a potential mentor for
conntinuing this project.

> I don't think that it's too small (in fact, it was probably an error on
> my part to include this as a potential stretch goal in Abhradeep's
> project). We don't have any evidence that it's a good or bad idea.
>
> Abhradeep promised[1] that he'd include some performance work in his
> next version of that series. I think the main things we'd be interested
> in are:
>
>   - Does using Roaring provide a file-size advantage over
>     EWAH-compressed bitmaps?
>   - Does Roaring make it faster to inflate bitmaps? To deflate them?

As far as I understand it, after reading articles about EWAH[2] and
about Roaring Bitmaps[3][4], the Roaring have the advantage that you
don't need to decompress (inflate) bitmaps to perform bitwise operations
on them.

Run-Length-Encoding (RLE) formats like EWAH can be made to perform
operations without decompressing, but only if operations are symmetric.
The AND and OR operations are symmetrical, but AND NOT is not.  The last
is used by Git to find "want"-ed that are not present (not "have") is
not.  That is why Git needs to decompress bitmap and perform operation.

If I understand it correctly, for both cases (EWAH and Roaring) you can
do membership check without decompressing bitmap.

[2] Daniel Lemire et al. "Sorting improves word-aligned bitmap indexes",
    arXiv:0901.3751

[3] Samy Chambi, Daniel Lemire et al. "Optimizing Druid with Roaring
    bitmaps", https://dl.acm.org/doi/10.1145/2938503.2938515
[4] Daniel Lemire et al. "Roaring Bitmaps: Implementation of an
    Optimized Software Library", arXiv:1709.07821v3

>
> Deflating bitmaps doesn't matter as much, IMHO, since that is a cost
> that we pay only when we first have to compress bitmaps before writing
> them. But if we could significantly reduce the inflation cost, that
> would be an advantage to using Roaring+Run bitmaps over EWAH ones since
> they would be faster to decompress at read-time.

Well, if Roaring were to be significantly slower when deflating, but
only slightly faster when using / inflating, that would affect their
evaluation.

>
> [1]: https://lore.kernel.org/git/[email-masked]/

Regards,
--
Jakub Narębski